#ifndef _MEM2REG_H
#define _MEM2REG_H
#include "Instruction.h"
#include "Multithread.h"
#include "dominatorTree.h"
#include <algorithm>
#include <list>
#include <stack>
#include <unordered_map>
#include <vector>

class Mem2Reg {
  private:
    Unit *unit;
    Function *func_{};
    dominatorTree *dom{};
    bool flag = 1;
    // std::vector<AllocaInstruction*> alloca_insts;
    // std::map<Operand*, std::stack<Operand*>> old_new_stack;
    // std::vector<BinaryInstruction*> add_insts;
  public:
    Mem2Reg(Unit *_unit) : unit(_unit){};
    bool checkFunc(SymbolEntry *se);
    bool getFlag() { return flag; };
    void execute();
    void execute2();
    void execute(Function *function, bool p = 0);
    // // 寄存器重命名
    // void rename(Function* function);
    // void rename(BasicBlock *bb);
};

#endif